foreach name [array names env STOOOP*] {unset env($name)}                                ;# reset any existing environment variables
set env(STOOOPCHECKOBJECTS) {}
source stooop.tcl
namespace import stooop::*

### objects checking from within derived class constructor

# expected output:
## stooop::record invoked from main script
## stooop::report invoked from main script:
## + ::b(1) created in main script
## + ::c(2) created in ::b::b
## stooop::record invoked from namespace ::A
## stooop::report invoked from namespace ::A:
## + ::A::b(3) created in namespace ::A
## + ::c(4) created in ::A::b::b

class a {
    proc a {this i} {}
    proc ~a {this} {}
}
class b {
    proc b {this} a {[new c]} {}
    proc ~b {this} {}
}
class c {
    proc c {this} {}
    proc ~c {this} {}
}
stooop::record
new b
stooop::report

class A {
    class a {
        proc a {this i} {}
        proc ~a {this} {}
    }
    class b {
        proc b {this} a {[new c]} {}
        proc ~b {this} {}
    }
    class c {
        proc c {this} {}
        proc ~c {this} {}
    }
    stooop::record
    new b
    stooop::report
}
